#define STAT_STR_SIZE 48
#define TASK_SIZE 2048
#define VARIANT_SIZE 1024
#define VAR_NUMBER 12
#define PATH_SIZE 32
#define STRING_COEFFICIENT 0.6
#define MAX_STRING 8
//#include <stdio.h>

class vrnt
    {
    public:
    char text[VARIANT_SIZE];
    bool loaded,correct;
    int GetCoefficient(float fChar);
    };

int vrnt::GetCoefficient(float fChar)
    {
    float fCoefficient;
    int nCoefficient=1;
    fCoefficient=strlen(text);
    fCoefficient=fCoefficient/fChar;
    for(int i=1;i<MAX_STRING;i++) {if(fCoefficient>(STRING_COEFFICIENT*i)) nCoefficient=i+1;}
    return nCoefficient;
    }

class QuestionClass
    {
    public:
    char task[TASK_SIZE];
    vrnt variant[VAR_NUMBER];
    bool loaded, completed;
    int GetSumCoefficient(int nUpTo,float fChar);
    int showed,nId;
    QuestionClass();
    QuestionClass *Next;
    };

QuestionClass::QuestionClass()
    {
    loaded=FALSE;
    showed=0;
    completed=FALSE;
    for(int i=0;i<TASK_SIZE;i++) {task[i]='\0';}
    }

int QuestionClass::GetSumCoefficient(int nUpTo, float fChar)
    {
    int nSum=0;
    for(int i=0;i<nUpTo;i++) nSum+=variant[i].GetCoefficient(fChar);
    return nSum;
    }

class TopicClass
    {
    public:
    int length;
    int nCurLevel;
    QuestionClass First;
    QuestionClass *Last;
    QuestionClass *myNew(QuestionClass *Pred);
    QuestionClass *Get(int nId_to_find);
    void LoadQuestions(char szPath[PATH_SIZE]);
    void UnloadQuestions();
    int GetNextQuestion(int nStart);
//    char *GetStat(int nLevel);
//    char *GetStat(int nLevel,bool bNeedMessage,HWND hWnd);
    void GetStat(int nLevel,bool bNeedMessage,HWND hWnd);
//int GetID(int qNumber);
    int GetIDComponent(int nEnd);
    TopicClass();
    };

TopicClass::TopicClass()
    {
    length=1;
    First.nId=0;
    First.Next=&First;
    }

int TopicClass::GetIDComponent(int nEnd)
    {
    int nIDComponent=0;
    for(int i=0;i<nEnd;i++) {for(int j=0;j<VAR_NUMBER;j++) {if(Get(i)->variant[j].loaded) {nIDComponent++;}}}
    return nIDComponent;
    }

int TopicClass::GetNextQuestion(int nStart)
    {
    QuestionClass *Temp;
    Temp=&First;
    Temp=Get(nStart);
    for(int i=nStart;i<length;i++)
    {
	if((!Temp->completed)&&(Temp->loaded)) {return i;}
	Temp=Temp->Next;
    }
    return -1;
    }

QuestionClass *TopicClass::myNew(QuestionClass *Pred)
    {
    QuestionClass *Vsp;
    Vsp = (QuestionClass *) malloc(sizeof(QuestionClass));
//    for(int i=0;i<TASK_SIZE;i++) {Vsp->task[i]='\0';}
    Vsp->Next=Pred->Next;
    Pred->Next=Vsp;
    Vsp->nId=Pred->nId+1;
    length++;
    Last=Vsp;
    return Vsp;
    }

QuestionClass *TopicClass::Get(int nId_to_find)
    {
    QuestionClass *Temp;
    Temp=&First;
//    for(int i=0;i<length;i++)
    for(int i=0;i<nId_to_find;i++)
        {
//        if(Temp->nId==nId_to_find) {return Temp;}
	Temp=Temp->Next;
        }
    return Temp;
//    return NULL;
    }

void TopicClass::LoadQuestions(char szPath[PATH_SIZE])
    {
    QuestionClass *Temp;
    DWORD NumRead;
    HANDLE hFile;
    char ch;
    bool new_str=1,istask,visible;
    int i,j;
    Temp=&First;
    int QCount=-1;
    hFile=CreateFile(szPath,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
    do
    {
        visible=TRUE;
        ReadFile(hFile,&ch,1,&NumRead,NULL);
        if(new_str)
        {
            if (ch==(char)9) {istask=false;j++;Temp->variant[j].loaded=1;i=0;}
            else
        	{
    	        istask=true;QCount++;
    	        if(QCount==0) {Temp=&First;} else {Temp=myNew(Temp);}
    	        Temp->loaded=1;Temp->completed=0;
//Temp->nId=QCount;
    	        j=-1;i=0;
    	        }
            new_str=false;
        }
        if(ch==(char)10) {new_str=true;}
        if(ch==(char)13|(ch==(char)10)){visible=false;}
        if((istask)&(visible)) {Temp->task[i]=ch;i++;}
        else
        {
            if((ch=='+')&(i==0)){Temp->variant[j].correct=1;visible=FALSE;}
            if((ch=='-')&(i==0)){Temp->variant[j].correct=0;visible=FALSE;}
            if((ch==(char)9)|(ch==(char)10)|(ch==(char)13)){visible=FALSE;}
            if(visible){Temp->variant[j].text[i]=ch;i++;}
        }
    }
    while(NumRead!=0);
    }

void TopicClass::UnloadQuestions()
    {
    int i=0;
    QuestionClass *Temp,*rm;
    Temp=First.Next;
    for(i=0;i<length-1;i++)
        {
	Temp=Temp->Next;
	rm=Temp;
	free(rm);
        }
    for(i=0;i<TASK_SIZE;i++) {First.task[i]='\0';}
    First.loaded=FALSE;
    First.showed=0;
    First.completed=FALSE;
    }

void TopicClass::GetStat(int nLevel,bool bNeedMessage,HWND hWnd)
    {
    int nSeen=0,nCorrect=0,nLeft=0;
    float fProcent;
    char szResult[STAT_STR_SIZE];
//    Vsp = (QuestionClass *) malloc(sizeof(QuestionClass));
    QuestionClass *Temp;
    Temp=&First;
    for(int i=0;i<length;i++)
    {
        if(Temp->loaded)
        {
            if(Temp->showed==nLevel)
            {
            nSeen++;
            if(Temp->completed) {nCorrect++;}
            }
        if((Temp->showed<nLevel)&&(!Temp->completed)) {nLeft++;}
        }
    }
    fProcent=nCorrect;
    if(nSeen!=0) {fProcent=(fProcent/nSeen)*100;}
    else fProcent=0;
    sprintf(szResult,"Правильно %3.3f %%, осталось %d",fProcent,nLeft);
    SetWindowText(hWnd,szResult);
    if(bNeedMessage)
        {
    	sprintf(szResult,"Правильных %d, всего %d (%3.3f %%)", nCorrect,nSeen,fProcent);
    	MessageBox(hWnd,szResult,"Statistics",MB_OK);
    	}
//    return szResult;
    }
